## tlfloat 1.15.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

option(BUILD_LIBS "Build and install the library" ON)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_UTILS "Build utilities" ON)
option(BUILD_BENCH "Build benchmarking tools" OFF)
option(ENABLE_INTSQRT "Enable fully integer sqrt" OFF)
option(ENABLE_INLINING "Enable extensive function inlining" OFF)
option(ENABLE_LTO "Enable LTO" OFF)
option(ENABLE_ASAN "Enable address sanitizer" OFF)
option(ENABLE_CUDA_TEST "Build CUDA tester" OFF)
option(INSTALL_CONTINUOUS_TESTERS "Install continuous testers" OFF)
option(ENABLE_DOXYGEN "Enable generating documents with Doxygen" OFF)
option(ENABLE_COVERAGE "Enable generating coverage data" OFF)
option(ENABLE_ARCH_OPTIMIZATION "Enable architecture-specific optimization upon building library" ON)
option(BUILD_EXHAUSTIVE_TESTING "Build exhaustive testing for 16-bit and 32-bit arguments" OFF)
option(ENABLE_EXHAUSTIVE_TESTING "Enable exhaustive testing for 16-bit and 32-bit arguments" OFF)
set(SET_COMPILER_SUPPORTS_INT128 "auto" CACHE STRING "Set whether the compiler supports __int128 type")
set(SET_COMPILER_SUPPORTS_ISOFLOAT128 "auto" CACHE STRING "Set whether the compiler supports _Float128 type")
set(SET_COMPILER_SUPPORTS_FLOAT128 "auto" CACHE STRING "Set whether the compiler supports __float128 type")
set(SET_LONGDOUBLE_IS_FLOAT128 "auto" CACHE STRING "Set whether long double is IEEE binary128")

#

set(TLFLOAT_VERSION_MAJOR 1)
set(TLFLOAT_VERSION_MINOR 15)
set(TLFLOAT_VERSION_PATCH 0)
set(TLFLOAT_VERSION ${TLFLOAT_VERSION_MAJOR}.${TLFLOAT_VERSION_MINOR}.${TLFLOAT_VERSION_PATCH})
set(TLFLOAT_SOVERSION ${TLFLOAT_VERSION_MAJOR})

message(STATUS "Configuring TLFloat ${TLFLOAT_VERSION_MAJOR}.${TLFLOAT_VERSION_MINOR}.${TLFLOAT_VERSION_PATCH}")

project(tlfloat)

#

enable_language(CXX)
set(CMAKE_CXX_STANDARD 20)

if(ENABLE_CUDA_TEST)
  enable_language(CUDA)
  set(CMAKE_CUDA_ARCHITECTURES 50)
endif()

# CMake configuration

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source build not supported")
endif()

set(LIBRARY_OUTPUT_PATH "${CMAKE_BINARY_DIR}/lib")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}/bin")

include_directories("${PROJECT_SOURCE_DIR}/src/include")
include_directories("${PROJECT_BINARY_DIR}/include")

set(TMPDIR "${CMAKE_BINARY_DIR}/tmp")
file(MAKE_DIRECTORY "${TMPDIR}")

if (NOT EXISTS ${CMAKE_BINARY_DIR}/CMakeCache.txt)
  if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
  endif()
endif()

include(GNUInstallDirs)

# Include packages

find_library(LIB_MPFR mpfr)
message(STATUS "LIB_MPFR : " ${LIB_MPFR})
if (LIB_MPFR)
  find_path(MPFR_INCLUDE_DIR mpfr.h)
  message(STATUS "MPFR_INCLUDE_DIR : " ${MPFR_INCLUDE_DIR})
  if (MPFR_INCLUDE_DIR)
    include_directories("${MPFR_INCLUDE_DIR}")
  endif()
endif()

find_library(LIBM m)
if (NOT LIBM)
  set(LIBM "")
endif()

find_package(OpenMP)

# Detect compiler capabilities

include(CheckCXXSourceCompiles)

if (SET_COMPILER_SUPPORTS_INT128 STREQUAL "auto")
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  CHECK_CXX_SOURCE_COMPILES("
int main(int argc, char **argv) {
  __int128_t i = argc;
  __uint128_t u = argc;
  return (int)(i % 10) + (int)(u % 10);
}" TLFLOAT_COMPILER_SUPPORTS_INT128)
  set(CMAKE_REQUIRED_FLAGS)
else()
  if (SET_COMPILER_SUPPORTS_INT128)
    set(TLFLOAT_COMPILER_SUPPORTS_INT128 ON)
  else()
    set(TLFLOAT_COMPILER_SUPPORTS_INT128 OFF)
  endif()
  message(STATUS "Manually setting TLFLOAT_COMPILER_SUPPORTS_INT128 : " ${TLFLOAT_COMPILER_SUPPORTS_INT128})
endif()

if (SET_COMPILER_SUPPORTS_ISOFLOAT128 STREQUAL "auto")
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  CHECK_CXX_SOURCE_COMPILES("
#include <bit>
struct s { long long x, y; };
int main(int argc, char **argv) {
  constexpr s a = std::bit_cast<s>(_Float128(0.1234)*_Float128(56.789));
  static_assert((a.x ^ a.y) == 0xc7d695c93a4e2b71LL);
  _Float128 i = argc;
  return (int)i;
}
" TLFLOAT_COMPILER_SUPPORTS_ISOFLOAT128)
  set(CMAKE_REQUIRED_FLAGS)
else()
  if (SET_COMPILER_SUPPORTS_ISOFLOAT128)
    set(TLFLOAT_COMPILER_SUPPORTS_ISOFLOAT128 ON)
  else()
    set(TLFLOAT_COMPILER_SUPPORTS_ISOFLOAT128 OFF)
  endif()
  message(STATUS "Manually setting TLFLOAT_COMPILER_SUPPORTS_ISOFLOAT128 : " ${TLFLOAT_COMPILER_SUPPORTS_ISOFLOAT128})
endif()

if (SET_COMPILER_SUPPORTS_FLOAT128 STREQUAL "auto")
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  CHECK_CXX_SOURCE_COMPILES("
#include <bit>
struct s { long long x, y; };
int main(int argc, char **argv) {
  constexpr s a = std::bit_cast<s>(__float128(0.1234)*__float128(56.789));
  static_assert((a.x ^ a.y) == 0xc7d695c93a4e2b71LL);
  __float128 i = argc;
  return (int)i;
}
" TLFLOAT_COMPILER_SUPPORTS_FLOAT128)
  set(CMAKE_REQUIRED_FLAGS)
else()
  if (SET_COMPILER_SUPPORTS_FLOAT128)
    set(TLFLOAT_COMPILER_SUPPORTS_FLOAT128 ON)
  else()
    set(TLFLOAT_COMPILER_SUPPORTS_FLOAT128 OFF)
  endif()
  message(STATUS "Manually setting TLFLOAT_COMPILER_SUPPORTS_FLOAT128 : " ${TLFLOAT_COMPILER_SUPPORTS_FLOAT128})
endif()

if (SET_LONGDOUBLE_IS_FLOAT128 STREQUAL "auto")
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  CHECK_CXX_SOURCE_COMPILES("
#include <bit>
struct s { long long x, y; };
int main(void) {
  constexpr s a = std::bit_cast<s>((long double)0.1234*(long double)56.789);
  static_assert((a.x ^ a.y) == 0xc7d695c93a4e2b71LL);
}
" TLFLOAT_LONGDOUBLE_IS_FLOAT128)
  set(CMAKE_REQUIRED_FLAGS)
else()
  if (SET_LONGDOUBLE_IS_FLOAT128)
    set(TLFLOAT_LONGDOUBLE_IS_FLOAT128 ON)
  else()
    set(TLFLOAT_LONGDOUBLE_IS_FLOAT128 OFF)
  endif()
  message(STATUS "Manually setting TLFLOAT_LONGDOUBLE_IS_FLOAT128 : " ${TLFLOAT_LONGDOUBLE_IS_FLOAT128})
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_REQUIRED_FLAGS "-march=armv8.2-a+fp16")
  CHECK_CXX_SOURCE_COMPILES("
#include <cstdlib>
#include <arm_fp16.h>
int main(int argc, char **argv) {
  __fp16 hu = vaddh_f16(__fp16(atof(argv[1])), __fp16(0.2));
  bool b = vceqh_f16(__fp16(atof(argv[1])), __fp16(0.2));
  return (int)hu + (int)b;
}" TLFLOAT_COMPILER_SUPPORTS_ARM_FP16)
  set(CMAKE_REQUIRED_FLAGS)
endif()

if (CMAKE_CXX_COMPILER_TARGET)
  set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
endif()
CHECK_CXX_SOURCE_COMPILES("
#include <cstdlib>
#include <cstdint>
#include <bit>
int main(int argc, char **argv) {
__fp16 a = (__fp16)(float)atof(argv[1]);
__uint16_t u = std::bit_cast<__uint16_t>(a);
a = std::bit_cast<__fp16>(u);
return (float)a; }
" TLFLOAT_COMPILER_SUPPORTS_FP16)

CHECK_CXX_SOURCE_COMPILES("
#include <cstdlib>
#include <cstdint>
#include <bit>
int main(int argc, char **argv) {
__bf16 a = (__bf16)(float)atof(argv[1]);
__uint16_t u = std::bit_cast<__uint16_t>(a);
a = std::bit_cast<__bf16>(u);
return (float)a; }
" TLFLOAT_COMPILER_SUPPORTS_BF16)

CHECK_CXX_SOURCE_COMPILES("
#include <cstdio>
#include <features.h>
#ifndef __GLIBC__
#error GLIBC macro not defined
#endif
int main(int argc, char **argv) {}" BUILDING_WITH_GLIBC)
set(CMAKE_REQUIRED_FLAGS)

if (LIB_MPFR)
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  set(CMAKE_REQUIRED_LIBRARIES ${LIB_MPFR})
  CHECK_CXX_SOURCE_COMPILES("
#define MPFR_WANT_FLOAT128
#include <mpfr.h>
int main() {}" TLFLOAT_ENABLE_MPFR_WANT_FLOAT128)

  CHECK_CXX_SOURCE_COMPILES("
#include <mpfr.h>
int main() {
mpfr_t mx;
mpfr_sinpi(mx, mx, GMP_RNDN);
}"
    TLFLOAT_ENABLE_MPFR_SINPI)
  set(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_FLAGS)
endif()

if (TLFLOAT_COMPILER_SUPPORTS_FLOAT128)
  if (CMAKE_CXX_COMPILER_TARGET)
    set(CMAKE_REQUIRED_FLAGS "--target=${CMAKE_CXX_COMPILER_TARGET}")
  endif()
  set(CMAKE_REQUIRED_LIBRARIES quadmath)
  CHECK_CXX_SOURCE_COMPILES("
#include <cstdio>
#include <quadmath.h>
int main(int argc, char **argv) {
__float128 f = atof(argv[1]);
printf(\"%g\", (double)sinq(f));
}" TLFLOAT_ENABLE_LIBQUADMATH)
  set(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_REQUIRED_FLAGS)
endif()

# Setting up memory-leak checks

include(CTest)
set(MEMORYCHECK_COMMAND_OPTIONS "--leak-check=full --error-exitcode=1")

if (ENABLE_VALGRIND AND NOT CMAKE_CROSSCOMPILING)
  find_program(VALGRIND "valgrind")
  message(STATUS "VALGRIND : " ${VALGRIND})
endif()

# Compiler options

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fcompare-debug-second -fconstexpr-ops-limit=1000000000 -fno-math-errno")
  set(INLINE_CXX_FLAGS "--inline-limit=1000000")
  set(NOEXCEPT_CXX_FLAGS "-fno-exceptions;-fno-rtti")
  if(CMAKE_SYSTEM_PROCESSOR MATCHES "i[3-6]86")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse -msse2")
  endif()
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-g -Og")
  if (ENABLE_ASAN)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "(arm64|aarch64)")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=hwaddress -static-libasan -fno-exceptions")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=hwaddress -static-libasan")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -static-libasan -fno-exceptions")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -static-libasan")
    endif()
  endif()
  if (COMMAND_GOLD)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=gold")
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fconstexpr-steps=1000000000 -fno-math-errno")
  set(INLINE_CXX_FLAGS "-mllvm;-inline-threshold=100000")
  set(NOEXCEPT_CXX_FLAGS "-fno-exceptions;-fno-rtti")
  if(CMAKE_SYSTEM_PROCESSOR MATCHES "i[3-6]86")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse -msse2")
  endif()
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-g -Og")
  if (ENABLE_ASAN)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "(arm64|aarch64)")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=hwaddress")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=hwaddress")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
    endif()
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND WIN32)
  get_filename_component(COMPILER_BASENAME "${CMAKE_CXX_COMPILER}" NAME_WE)
  string(TOLOWER "${COMPILER_BASENAME}" LC_COMPILER_BASENAME)

  if ("${LC_COMPILER_BASENAME}" STREQUAL "clang-cl")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /clang:-fconstexpr-steps=1000000000")
    set(INLINE_CXX_FLAGS "/clang:-mllvm;/clang:-inline-threshold=100000")
    set(NOEXCEPT_CXX_FLAGS "")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fconstexpr-steps=1000000000 -fno-math-errno")
    set(INLINE_CXX_FLAGS "-mllvm;-inline-threshold=100000")
    set(NOEXCEPT_CXX_FLAGS "-fno-exceptions;-fno-rtti")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-g -Og")
  endif()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /constexpr:steps1000000000")
  set(INLINE_CXX_FLAGS "")
  set(NOEXCEPT_CXX_FLAGS "")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" LC_CMAKE_BUILD_TYPE)

if (WIN32)
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS=1 _CRT_NONSTDC_NO_DEPRECATE=1)
endif()

if (NOT "${LC_CMAKE_BUILD_TYPE}" STREQUAL "release")
  add_compile_definitions(DEBUG=1)
endif()

if (NOT ENABLE_ARCH_OPTIMIZATION)
  add_definitions(-DTLFLOAT_DISABLE_ARCH_OPTIMIZATION)
endif()

if (ENABLE_LTO)
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()

# Setting up for coverage report

if (ENABLE_COVERAGE)
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage -fprofile-arcs -ftest-coverage")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -fprofile-arcs -ftest-coverage")
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT WIN32)

=== src/CMakeLists.txt ===
add_subdirectory("tlfloat")
add_subdirectory("util")
if (BUILD_TESTS)
  add_subdirectory("tester") # tester has to come at last
endif()

=== src/tester/CMakeLists.txt ===
if (TLFLOAT_COMPILER_SUPPORTS_INT128)
  add_executable(test_bigint3 test_bigint3.cpp)
  add_test(NAME test_bigint3 COMMAND test_bigint3)
endif()

if (BUILD_LIBS)
  add_executable(test_bigint4 test_bigint4.cpp)
  target_link_libraries(test_bigint4 tlfloat)
  add_test(NAME test_bigint4 COMMAND test_bigint4)
endif()

if (BUILDING_WITH_GLIBC AND BUILD_LIBS)
   add_executable(test_printf test_printf.cpp)
   target_link_libraries(test_printf tlfloat)
   add_test(NAME test_printf COMMAND test_printf)
   set_tests_properties(test_printf PROPERTIES COST "2")
endif()

add_executable(test_bigint2 test_bigint2.cpp)
add_test(NAME test_bigint2 COMMAND test_bigint2)

if(ENABLE_CUDA_TEST)
  add_executable(test_cuda test_cuda.cu)
  target_compile_options(test_cuda PRIVATE "--maxrregcount;128;--expt-relaxed-constexpr;--std;c++20")
  add_test(NAME test_cuda COMMAND test_cuda)
  set_tests_properties(test_cuda PROPERTIES COST "3")
endif()

add_executable(test_arith test_arith.cpp)
add_executable(test_arith_noopt test_arith.cpp)
target_compile_definitions(test_arith_noopt PRIVATE TLFLOAT_DISABLE_ARCH_OPTIMIZATION=1)
if (TLFLOAT_ENABLE_LIBQUADMATH)
  target_link_libraries(test_arith quadmath)
  target_link_libraries(test_arith_noopt quadmath)
endif()
add_test(NAME test_arith COMMAND test_arith)
set_tests_properties(test_arith PROPERTIES COST "1")
add_test(NAME test_arith_noopt COMMAND test_arith_noopt)
set_tests_properties(test_arith_noopt PROPERTIES COST "1")

if (INSTALL_CONTINUOUS_TESTERS)
  install(
    TARGETS test_arith test_arith_noopt
    DESTINATION "${INSTALL_BINDIR}"
    COMPONENT tester
    )
endif()

add_executable(test_hash test_hash.cpp)
add_test(NAME test_hash COMMAND test_hash 73aabab9b968750a42459cef0ec1e1170160b1762713b9eceffa7f0d6555e11f)
set_tests_properties(test_hash PROPERTIES COST "2")

add_executable(test_hash_noopt test_hash.cpp)
target_compile_definitions(test_hash_noopt PRIVATE TLFLOAT_DISABLE_ARCH_OPTIMIZATION=1)
add_test(NAME test_hash_noopt COMMAND test_hash_noopt 73aabab9b968750a42459cef0ec1e1170160b1762713b9eceffa7f0d6555e11f)
set_tests_properties(test_hash_noopt PROPERTIES COST "2")

if (BUILD_LIBS)
  add_executable(test_printf_hash test_printf_hash.cpp)
  target_link_libraries(test_printf_hash tlfloat)
  add_test(NAME test_printf_hash COMMAND test_printf_hash 2398daffe3037ec51f353ed9da2221f53d4d86fc554e0f93873381f74e1d352c)
  set_tests_properties(test_printf_hash PROPERTIES COST "2")
endif()

if (LIB_MPFR)
  add_executable(test_mpfr test_mpfr.cpp)
  target_link_libraries(test_mpfr ${LIB_MPFR})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(test_mpfr quadmath)
  endif()
  add_test(NAME test_mpfr COMMAND test_mpfr)
  set_tests_properties(test_mpfr PROPERTIES COST "2")

  add_executable(test_mpfr_noopt test_mpfr.cpp)
  target_compile_definitions(test_mpfr_noopt PRIVATE TLFLOAT_DISABLE_ARCH_OPTIMIZATION=1)
  target_link_libraries(test_mpfr_noopt ${LIB_MPFR})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(test_mpfr_noopt quadmath)
  endif()
  add_test(NAME test_mpfr_noopt COMMAND test_mpfr_noopt)
  set_tests_properties(test_mpfr_noopt PROPERTIES COST "2")

  if (INSTALL_CONTINUOUS_TESTERS)
    install(
      TARGETS test_mpfr test_mpfr_noopt
      DESTINATION "${INSTALL_BINDIR}"
      COMPONENT tester
      )
  endif()

  add_executable(tester1 tester1.cpp)
  target_link_libraries(tester1 ${LIB_MPFR})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(tester1 quadmath)
  endif()
  add_test(NAME tester1 COMMAND tester1)
  set_tests_properties(tester1 PROPERTIES COST "2")

  add_executable(tester1_noopt tester1.cpp)
  target_compile_definitions(tester1_noopt PRIVATE TLFLOAT_DISABLE_ARCH_OPTIMIZATION=1)
  target_link_libraries(tester1_noopt ${LIB_MPFR})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(tester1_noopt quadmath)
  endif()
  add_test(NAME tester1_noopt COMMAND tester1_noopt)
  set_tests_properties(tester1_noopt PROPERTIES COST "2")
endif()

#

if (LIB_MPFR AND (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_SYSTEM_PROCESSOR MATCHES "(arm64|aarch64)") AND BUILD_EXHAUSTIVE_TESTING)
  add_executable(test_exhaustive32 test_exhaustive32.cpp)
  target_link_libraries(test_exhaustive32 ${LIB_MPFR})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(test_exhaustive32 quadmath)
  endif()

  add_executable(test_exhaustive_bf16_mpfr test_exhaustive_bf16_mpfr.cpp)
  target_link_libraries(test_exhaustive_bf16_mpfr ${LIB_MPFR})

  if (OpenMP_CXX_FOUND)
    target_compile_options(test_exhaustive32 PRIVATE ${OpenMP_CXX_FLAGS})
    target_link_options(test_exhaustive32 PRIVATE ${OpenMP_CXX_FLAGS})
    target_include_directories(test_exhaustive32 PRIVATE ${OpenMP_CXX_INCLUDE_DIRS})

    target_compile_options(test_exhaustive_bf16_mpfr PRIVATE ${OpenMP_CXX_FLAGS})
    target_link_options(test_exhaustive_bf16_mpfr PRIVATE ${OpenMP_CXX_FLAGS})
    target_include_directories(test_exhaustive_bf16_mpfr PRIVATE ${OpenMP_CXX_INCLUDE_DIRS})
  endif()

  if (ENABLE_EXHAUSTIVE_TESTING)
    add_test(NAME test_exhaustive32 COMMAND test_exhaustive32)
    add_test(NAME test_exhaustive_bf16_mpfr COMMAND test_exhaustive_bf16_mpfr)
  endif()

  if (INSTALL_CONTINUOUS_TESTERS)
    install(
      TARGETS test_exhaustive32 test_exhaustive_bf16_mpfr
      DESTINATION "${INSTALL_BINDIR}"
      COMPONENT tester
      )
  endif()
endif()

#

if (TLFLOAT_COMPILER_SUPPORTS_ARM_FP16 AND LIB_MPFR AND BUILD_EXHAUSTIVE_TESTING)
  add_executable(test_exhaustive16 test_exhaustive16.cpp)
  target_link_libraries(test_exhaustive16 ${LIB_MPFR})
  target_compile_options(test_exhaustive16 PRIVATE "-march=armv8.2-a+fp16")
  if (OpenMP_CXX_FOUND)
    target_compile_options(test_exhaustive16 PRIVATE ${OpenMP_CXX_FLAGS})
    target_link_options(test_exhaustive16 PRIVATE ${OpenMP_CXX_FLAGS})
    target_include_directories(test_exhaustive16 PRIVATE ${OpenMP_CXX_INCLUDE_DIRS})
  endif()
  if (ENABLE_EXHAUSTIVE_TESTING)
    add_test(NAME test_exhaustive16 COMMAND test_exhaustive16)
  endif()

  if (INSTALL_CONTINUOUS_TESTERS)
    install(
      TARGETS test_exhaustive16
      DESTINATION "${INSTALL_BINDIR}"
      COMPONENT tester
      )
  endif()
endif()

if (TLFLOAT_COMPILER_SUPPORTS_BF16 AND BUILD_EXHAUSTIVE_TESTING)
  add_executable(test_exhaustive_bf16 test_exhaustive_bf16.cpp)
  if (OpenMP_CXX_FOUND)
    target_compile_options(test_exhaustive_bf16 PRIVATE ${OpenMP_CXX_FLAGS})
    target_link_options(test_exhaustive_bf16 PRIVATE ${OpenMP_CXX_FLAGS})
    target_include_directories(test_exhaustive_bf16 PRIVATE ${OpenMP_CXX_INCLUDE_DIRS})
  endif()
  if (ENABLE_EXHAUSTIVE_TESTING)
    add_test(NAME test_exhaustive_bf16 COMMAND test_exhaustive_bf16)
  endif()

  if (INSTALL_CONTINUOUS_TESTERS)
    install(
      TARGETS test_exhaustive_bf16
      DESTINATION "${INSTALL_BINDIR}"
      COMPONENT tester
      )
  endif()
endif()

#

if (BUILD_LIBS)
  add_library(test_octuple_obj OBJECT test_octuple.cpp)
  target_compile_definitions(test_octuple_obj PRIVATE TLFLOAT_NO_LIBSTDCXX=1)
  target_compile_options(test_octuple_obj PRIVATE ${NOEXCEPT_CXX_FLAGS})
  set_target_properties(test_octuple_obj PROPERTIES LINKER_LANGUAGE C)

  add_executable(test_octuple test_octuple_dummy.c)
  target_link_libraries(test_octuple test_octuple_obj tlfloat ${LIBM})
  set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
  set_target_properties(test_octuple PROPERTIES LINKER_LANGUAGE C)
  add_test(NAME test_octuple COMMAND test_octuple)

  add_executable(test_capi test_capi.c)
  target_link_libraries(test_capi tlfloat ${LIBM})
  if (TLFLOAT_ENABLE_LIBQUADMATH)
    target_link_libraries(test_capi quadmath)
  endif()
  set_target_properties(test_capi PROPERTIES LINKER_LANGUAGE C)
  add_test(NAME test_capi COMMAND test_capi)

  if(NOT (("${CMAKE_SYSTEM_NAME}" STREQUAL "Emscripten") OR
          (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
           CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "14.0.0")))
    add_executable(test_cpp11api test_cpp11api.cpp)
    target_link_libraries(test_cpp11api tlfloat)
    set_target_properties(test_cpp11api PROPERTIES CXX_STANDARD 11)
    add_test(NAME test_cpp11api COMMAND test_cpp11api)
    set_tests_properties(test_cpp11api PROPERTIES COST "1")

    add_executable(test_cpp11api20 test_cpp11api.cpp)
    target_link_libraries(test_cpp11api20 tlfloat)
    add_test(NAME test_cpp11api20 COMMAND test_cpp11api20)
    set_tests_properties(test_cpp11api20 PROPERTIES COST "1")
  endif()
endif()

=== src/util/CMakeLists.txt ===
if (BUILD_UTILS)
  if (LIB_MPFR)
    add_executable(mkrpitab mkrpitab.cpp)
    target_link_libraries(mkrpitab ${LIB_MPFR})
  endif()

  add_executable(genmathcoef genmathcoef.cpp)
endif()

add_library(donothing OBJECT donothing.cpp)
set_property(TARGET donothing PROPERTY INTERPROCEDURAL_OPTIMIZATION FALSE)

if (BUILD_BENCH)
  add_executable(bench_tlfloat_quad bench.cpp)
  target_compile_options(bench_tlfloat_quad PRIVATE ${INLINE_CXX_FLAGS})
  target_compile_definitions(bench_tlfloat_quad PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_TLFLOAT_QUAD=1)
  target_link_libraries(bench_tlfloat_quad donothing)

  add_executable(bench_tlfloat_octuple bench.cpp)
  target_compile_options(bench_tlfloat_octuple PRIVATE ${INLINE_CXX_FLAGS})
  target_compile_definitions(bench_tlfloat_octuple PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_TLFLOAT_OCTUPLE=1)
  target_link_libraries(bench_tlfloat_octuple donothing)

  if (NOT TLFLOAT_COMPILER_SUPPORTS_FLOAT128)
    add_executable(bench_tlfloat_quad_capi bench.cpp)
    target_compile_options(bench_tlfloat_quad_capi PRIVATE ${INLINE_CXX_FLAGS})
    target_compile_definitions(bench_tlfloat_quad_capi PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_TLFLOAT_QUAD_CAPI=1)
    target_link_libraries(bench_tlfloat_quad_capi tlfloat donothing)
  endif()

  add_executable(bench_tlfloat_octuple_capi bench.cpp)
  target_compile_options(bench_tlfloat_octuple_capi PRIVATE ${INLINE_CXX_FLAGS})
  target_compile_definitions(bench_tlfloat_octuple_capi PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_TLFLOAT_OCTUPLE_CAPI=1)
  target_link_libraries(bench_tlfloat_octuple_capi tlfloat donothing)

  if (TLFLOAT_ENABLE_LIBQUADMATH)
    add_executable(bench_libquadmath bench.cpp)
    target_link_libraries(bench_libquadmath quadmath donothing)
    target_compile_options(bench_libquadmath PRIVATE ${INLINE_CXX_FLAGS})
    target_compile_definitions(bench_libquadmath PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_LIBQUADMATH=1)
  endif()

  if (TLFLOAT_LONGDOUBLE_IS_FLOAT128)
    add_executable(bench_longdouble bench.cpp)
    target_compile_options(bench_longdouble PRIVATE ${INLINE_CXX_FLAGS})
    target_compile_definitions(bench_longdouble PRIVATE TLFLOAT_ENABLE_INLINING=1 CONFIG_LONGDOUBLE=1)
    target_link_libraries(bench_longdouble donothing)
  endif()
endif()

=== debian/changelog ===
tlfloat (1.15.0-2) unstable; urgency=medium

  * d/control: remove M-A: same from libtlfloat-dev due to file conflicts.
  * d/control: bump std-ver to 4.7.3 (no changes needed).
  * d/patches: add patch to fix FTBFS on ppc64el (closes: #1129014).

 -- Shengqi Chen <harry@debian.org>  Thu, 26 Feb 2026 15:39:35 +0800

tlfloat (1.15.0-1) unstable; urgency=medium

  * Initial upload (closes: #1118721).

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Oct 2025 21:32:34 +0800

=== debian/control ===
Source: tlfloat
Section: math
Standards-Version: 4.7.3
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 architecture-is-64-bit,
 libmpfr-dev <!nocheck>,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Homepage: https://github.com/shibatch/tlfloat
Vcs-Git: https://salsa.debian.org/science-team/tlfloat.git
Vcs-Browser: https://salsa.debian.org/science-team/tlfloat

Package: libtlfloat1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ template library for floating point operations (shared library)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains libtlfloat shared library.

Package: libtlfloat-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libtlfloat1 (= ${binary:Version})
Suggests: libtlfloat-doc
Description: C++ template library for floating point operations (development files)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains development files for libtlfloat.

Package: libtlfloat-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: C++ template library for floating point operations (documentation)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains API documentation for libtlfloat.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
DPKG_EXPORT_BUILDFLAGS = 1

ifneq (nodoc,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOC=ON
else
BUILD_DOC=OFF
endif

ifneq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_TESTS=ON
else
BUILD_TESTS=OFF
endif

# 32bit machines do not have __{,u}int128_t
# now they are already excluded by B-D architecture-is-64bit
# due to precision issues (could not pass unit tests)
ifneq (64,$(DEB_BUILD_ARCH_BITS))
BUILD_INTSQRT=OFF
else
BUILD_INTSQRT=ON
endif

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR = build

%:
	dh $@ --buildsystem=cmake+ninja --builddir=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DCMAKE_POSITION_INDEPENDENT_CODE=ON \
		-DBUILD_LIBS=ON -DBUILD_TESTS=$(BUILD_TESTS) -DENABLE_INLINING=ON \
		-DENABLE_INTSQRT=$(BUILD_INTSQRT) -DENABLE_DOXYGEN=$(BUILD_DOC)

override_dh_auto_test:
ifeq ($(BUILD_TESTS), ON)
# all tests are single-threaded and slow
	cd $(BUILDDIR) && env CTEST_PARALLEL_LEVEL=$(DEB_BUILD_OPTION_PARALLEL) ctest -E ".*noopt"
endif
